#! usr/bin/perl
-wT;
use strict;
use Browser::Open qw( open_browser );

my(%LECTURE, %chars, @str, @question, $x);
my $in = '-h';
my $delay = 3;
my $keys = 1;
$chars{'{aa}'} = chr(134);
$chars{'{AA}'} = chr(143);
$chars{'{ae}'} = chr(145);
$chars{'{AE}'} = chr(146);
$chars{'{a:}'} = chr(132);
$chars{'{e:}'} = chr(137);
$chars{'{i:}'} = chr(139);
$chars{'{o:}'} = chr(148);
$chars{'{u:}'} = chr(129);
$chars{'{y:}'} = chr(152);
$chars{'{A:}'} = chr(142);
$chars{'{O:}'} = chr(153);
$chars{'{U:}'} = chr(154);
$chars{'{n~}'} = chr(164);
$chars{'{N~}'} = chr(165);
$chars{'{C,}'} = chr(128);
$chars{'{c,}'} = chr(135);
$chars{'{o/}'} = chr(237);
$chars{'{sz}'} = chr(225);
srand;
SelectLanguage();

while () {
	if ($in eq '-h') {Print();}
	elsif ($in eq  '-b') {
		dbmclose(%LECTURE);
		exit;}
	elsif ($in eq '-i') {ShowLecture();}
	elsif ($in eq '-l') {DeleteEntry();}
	elsif ($in eq '-n') {NewEntry();}
	elsif ($in eq '-o') {OpenDBM();}
	elsif ($in eq '-p') {AugmentWeight();}
	elsif ($in eq '-s') {SelectLanguage();}
	elsif ($in eq  '-u') {$keys = ($keys) ? 0 : 1}
	elsif ($in eq '-v') {ListLessons();}
	elsif ($in eq '-w') {print $str[27] if undef eq open_browser('http://www.ingram-braun.net/public/programming/miscellaneous/vocabulary/');}
	elsif ($in eq '-z') {SetDelay();}
	else {Ask();}
	print $str[29];
	$in = <STDIN>;
	chomp($in);}
	
sub Ask {
	$x = $question[rand $#question];
	if ($keys) {print "\n ", $x, "\n";}
	else {print "\n ", $LECTURE{$x}, "\n";}
	select(undef,undef,undef,$delay);
	if (!$keys) {print " ", $x, "\n";}
	else {print " ", $LECTURE{$x}, "\n";}}
	
sub AugmentWeight {
	push(@question, $x, $x, $x, $x, $x);}
	
sub DeleteEntry
{
	my $ix;
	my @words = ShowLecture();
	print $str[15];
	do {
		print $str[16];
		$ix = <STDIN>;
	} until ($ix =~ /^\d+$/);
	if (--$ix > $#words) {
		print $str[14];}
	else {delete($LECTURE{$words[$ix]});}}
	
sub ListLessons {
	my($count, %lessons, $dbm);
	opendir(LESSON, '.') || die $str[28],"$!";
    while(readdir(LESSON)) {
		$lessons{$1}++ if /^(.*)\.(pag|dir)$/;
	}
    closedir LESSON;
	my @lessons = sort keys %lessons;
	grep {print ++$count, ': ',$_, "\n"} @lessons;
	dbmclose(%LECTURE);
	do {
		print $str[30];
		$dbm = <STDIN>;
	} until ($dbm =~ /^\d+$/ && $dbm <= $#lessons + 1);
	dbmopen(%LECTURE, $lessons[--$dbm], 0666) || die $str[23], $lessons[$dbm], $str[24], $!;
	LoadLecture();
}

sub LoadLecture {
	@question = keys %LECTURE;
	my $q = scalar(@question);
	if ($q == 0) {print $str[31];}
	elsif ($q == 1) {print $str[32], $q, $str[33];}
	else {print $str[34], $q, $str[35];}
}

sub NewEntry {
	my @chars = sort {lc($a) cmp lc($b)} keys %chars;
	grep {print " ", $chars{$_}, " = ", $_, "\n"} @chars;
	print $str[25];
	$in = <STDIN>;
	chomp($in);
	print $str[26];
	my $val = <STDIN>;
	chomp($val);
	if ($in eq "" || $val eq "") {print $str[17];}
	else {
		grep {$val =~ s/$_/$chars{$_}/g;} @chars;
		grep {$in =~ s/$_/$chars{$_}/g;} @chars;
		$LECTURE{$in} = $val;
		$x = $in;
		push(@question, $in);}}

sub OpenDBM {
	print $str[20];
	my $dbm = <STDIN>;
	chomp($dbm);
	print "\n";
	if ($dbm =~ m'(\\|\/|<|>|\?|\||\"|\*|\:)') {
		print $str[21], $1, $str[22];
		OpenDBM();}
	else {
		dbmopen(%LECTURE, $dbm, 0666) || die $str[23], $dbm, $str[24], $!;
		$keys = "true";
		LoadLecture();}}

sub SetDelay {
	use integer;
	print $str[18];
	$delay = <STDIN>;
	chomp($delay);
	print "\n";
	if ($delay =~ /\D/) {
		print $str[19];
		$delay = 3;}}

sub SelectLanguage {
	my $lang;
	print "\n Select Language by number:\n 1 = English\n 2 = Deutsch";
	do {
		print "\n";
		$lang = <STDIN>;
	} until ($lang == 1 || $lang == 2);
	if ($lang == 2) {
		$str[0] = " Zul$chars{'{a:}'}ssige Befehle:\n";
		$str[1] = " -b = Programm beenden\n";
		$str[2] = " -h = Hilfe (zeigt alle Befehle an)\n";
		$str[3] = " -i = Inhalt der aktuellen Lektion anzeigen\n";
		$str[4] = " -l = Eintrag zum L$chars{'{o:}'}schen ausw$chars{'{a:}'}hlen\n";
		$str[5] = " -n = neuen Eintrag eingeben\n";
		$str[6] = " -o = Lektion $chars{'{o:}'}ffnen oder neu anlegen\n";
		$str[7] = " -p = letzte Frage als Problemfrage h$chars{'{a:}'}ufiger aufrufen\n";
		$str[8] = " -s = Sprache $chars{'{a:}'}ndern\n";
		$str[9] = " -u = Lernrichtung umdrehen\n";
		$str[10] = " -v = Vorhandene Lektionen anzeigen und $chars{'{o:}'}ffnen\n";
		$str[11] = " -w = Webseite $chars{'{o:}'}ffnen\n";
		$str[12] = " -z = Zeitverz$chars{'{o:}'}gerung eingeben (Sekunden)\n";
		$str[13] = " Jede andere Eingabe (am einfachsten nur ENTER) ruft die n$chars{'{a:}'}chste Frage auf.\n\n";
		$str[14] = " Kein Eintrag ausgew$chars{'{a:}'}hlt\n";
		$str[15] = " Welcher Eintrag soll gel$chars{'{o:}'}scht werden? \n";
		$str[16] = "\n Nummer eingeben: ";
		$str[17] = " Eintr$chars{'{a:}'}ge m$chars{'{u:}'}ssen Zeichen enthalten!\n";
		$str[18] = " Neue Zeitverz$chars{'{o:}'}gerung (Sekunden): ";
		$str[19] = " Hier mu$chars{'{sz}'} eine Ganzzahl eingegeben werden!\n";
		$str[20] = "\n $chars{'{O:}'}ffne Lektion oder lege neue Lektion an: ";
		$str[21] = "\n Zeichen '";
		$str[22] = "' nicht erlaubt in Dateinamen!\n";
		$str[23] = "Kann Lektion ";
		$str[24] = " nicht $chars{'{o:}'}ffnen: ";
		$str[25] = " Neuer Eintrag: ";
		$str[26] = " Antwort: ";
		$str[27] = "\n Kommando ist auf diesem Computer nicht verf$chars{'{u:}'}gbar!";
		$str[28] = "Kann Verzeichnis nicht $chars{'{o:}'}ffnen: ";
		$str[29] = "\n weiter oder Befehl eingeben: ";
		$str[30] = "\n Nummer der Lektion eingeben: ";
		$str[31] = " Bisher keine Eintr$chars{'{a:}'}ge in dieser Lektion!\n";
		$str[32] = " Diese Lektion enth$chars{'{a:}'}lt nur";
		$str[33] = " Frage.\n";
		$str[34] = " Diese Lektion enth$chars{'{a:}'}lt ";
		$str[35] = " Fragen.\n";
		$str[36] = " #                  Vokabeltrainer                   #\n";
	}
	else {
		$str[0] = " Commands available\n";
		$str[1] = " -b = Quit\n";
		$str[2] = " -h = Show help\n";
		$str[3] = " -i = Show content of current lesson\n";
		$str[4] = " -l = Select entry for deletion\n";
		$str[5] = " -n = New entry\n";
		$str[6] = " -o = Make new or open lesson\n";
		$str[7] = " -p = Select last entry more often\n";
		$str[8] = " -s = Select language\n";
		$str[9] = " -u = Turn learning direction\n";
		$str[10] = " -v = Display available lessons and open\n";
		$str[11] = " -w = Open web page\n";
		$str[12] = " -z = Set delay (seconds)\n";
		$str[13] = " Every other input (usually ENTER) shows next question.\n\n";
		$str[14] = " No entry selected\n";
		$str[15] = " Select Entry for deletion \n";
		$str[16] = "\n Select number: ";
		$str[17] = " Entries must contain characters!\n";
		$str[18] = "New delay (seconds): ";
		$str[19] = " Delay must be an integer\n";
		$str[20] = "\n Open existing lesson or make new one: ";
		$str[21] = "\n Character '";
		$str[22] = "' not allowed in filenames!\n";
		$str[23] = "Cannot open lesson ";
		$str[24] = ": ";
		$str[25] = " New entry: ";
		$str[26] = " Answer: ";
		$str[27] = "\n Command not available on this computer!";
		$str[28] = "Cannot open directory: ";
		$str[29] = "\n Go on or provide command: ";
		$str[30] = "\n Lesson number: ";
		$str[31] = " No entries in this lesson yet!\n";
		$str[32] = " This lesson contains";
		$str[33] = " entry only.\n";
		$str[34] = " This lesson contains ";
		$str[35] = " entries.\n";
		$str[36] = " #               Vocabulary trainer                  #\n";
	}
}

sub ShowLecture
{
	my @words = sort {lc($a) cmp lc($b)} keys %LECTURE;
	my $i;
	grep {print " ", ++$i, ". ", $_, " = ", $LECTURE{$_}, "\n"} sort {lc($a) cmp lc($b)} keys %LECTURE;
	return @words;}

sub Print() {
	print "\n\n\n #####################################################\n";
	print " #                                                   #\n";
	print $str[36];
	print " #                       GPL3                        #\n";
	print " #          (c) 2001-2013 by Ingram Braun            #\n";
	print " #           http://www.ingram-braun.net/            #\n";
	print " #                                                   #\n";
	print " #####################################################\n\n";
	print $str[0],$str[1],$str[2],$str[3],$str[4],$str[5],$str[6],$str[7],$str[8],$str[9],$str[10],$str[11],$str[12],$str[13];
}




